Index: trunk/src/VBox/Installer/win/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/win/Makefile.kmk	(revision 71954)
+++ trunk/src/VBox/Installer/win/Makefile.kmk	(revision 71955)
@@ -995,5 +995,5 @@
 
 #
-# Repackaging script installation target.
+# Repackaging scripts and files.
 #
 INSTALLS += RePackScripts
@@ -1005,8 +1005,12 @@
 	Scripts/UnpackBlessedDrivers.cmd \
 	$(RePackScripts_0_OUTDIR)/sign-dual.cmd \
-	$(RePackScripts_0_OUTDIR)/sign-sha1.cmd
+	$(RePackScripts_0_OUTDIR)/sign-sha1.cmd \
+	$(RePackScripts_0_OUTDIR)/VMMR0.inf \
+	$(RePackScripts_0_OUTDIR)/VBoxExtPackPuel.inf
 RePackScripts_CLEAN = \
 	$(RePackScripts_0_OUTDIR)/sign-dual.cmd \
-	$(RePackScripts_0_OUTDIR)/sign-sha1.cmd
+	$(RePackScripts_0_OUTDIR)/sign-sha1.cmd \
+	$(RePackScripts_0_OUTDIR)/VMMR0.inf \
+	$(RePackScripts_0_OUTDIR)/VBoxExtPackPuel.inf
 
 $$(RePackScripts_0_OUTDIR)/sign-dual.cmd: | $$(dir $$@)
@@ -1028,3 +1032,12 @@
 		) )
 
+$$(RePackScripts_0_OUTDIR)/VMMR0.inf: $(PATH_SUB_CURRENT)/Scripts/VMMR0.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
+	$(call MSG_GENERATE,RePackScripts,$@,$<)
+	$(call VBOX_EDIT_INF_FN,$<,$@)
+
+$$(RePackScripts_0_OUTDIR)/VBoxExtPackPuel.inf: $(PATH_SUB_CURRENT)/Scripts/VBoxExtPackPuel.inf $(MAKEFILE_CURRENT) | $$(dir $$@)
+	$(call MSG_GENERATE,RePackScripts,$@,$<)
+	$(call VBOX_EDIT_INF_FN,$<,$@)
+
+
 include $(FILE_KBUILD_SUB_FOOTER)
Index: trunk/src/VBox/Installer/win/Scripts/PackDriversForSubmission.cmd
===================================================================
--- trunk/src/VBox/Installer/win/Scripts/PackDriversForSubmission.cmd	(revision 71954)
+++ trunk/src/VBox/Installer/win/Scripts/PackDriversForSubmission.cmd	(revision 71955)
@@ -175,5 +175,5 @@
 
 echo .Set DestinationDir=VMMR0>>                                                        "%_MY_OPT_DDF_FILE%"
-echo %_MY_OPT_BINDIR%\VMMR0.inf VMMR0.inf>>                                             "%_MY_OPT_DDF_FILE%"
+echo .\VMMR0.inf VMMR0.inf>>                                                            "%_MY_OPT_DDF_FILE%"
 echo %_MY_OPT_BINDIR%\VMMR0.r0 VMMR0.r0>>                                               "%_MY_OPT_DDF_FILE%"
 if "%_MY_OPT_WITH_PDB" == "1" echo %_MY_OPT_PDBDIR%\VMMR0.pdb VMMR0.pdb>>               "%_MY_OPT_DDF_FILE%"
Index: trunk/src/VBox/Installer/win/Scripts/VBoxExtPackPuel.inf
===================================================================
--- trunk/src/VBox/Installer/win/Scripts/VBoxExtPackPuel.inf	(revision 71955)
+++ trunk/src/VBox/Installer/win/Scripts/VBoxExtPackPuel.inf	(revision 71955)
@@ -0,0 +1,67 @@
+; $Id$
+;; @file
+; VBoxExtPackPuel - VirtualBox PUEL ExtPack drivers.
+;
+
+;
+; Copyright (C) 2018 Oracle Corporation
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; The contents of this file may alternatively be used under the terms
+; of the Common Development and Distribution License Version 1.0
+; (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+; VirtualBox OSE distribution, in which case the provisions of the
+; CDDL are applicable instead of those of the GPL.
+;
+; You may elect to license modified versions of this file under the
+; terms and conditions of either the GPL or the CDDL or both.
+;
+
+[Version]
+Signature   = "$Windows NT$"
+Class       = System
+ClassGuid   = {4d36e97d-e325-11ce-bfc1-08002be10318}
+CatalogFile = VBoxExtPackPuel.cat
+Provider    = %ORACLE%
+;edit-DriverVer  = 08/26/2008,2.00.0000
+
+[SourceDisksNames]
+1=%VBoxExtPackPuel.DskDesc%,"",,
+
+[SourceDisksFiles]
+VBoxEhciR0.r0=1
+VBoxNvmeR0.r0=1
+VBoxPciRawR0.r0=1
+
+[DestinationDirs]
+DefaultDestDir = 12
+VBoxExtPackPuelInstall.Files = 12
+
+[Manufacturer]
+;x86 %ORACLE%=VBoxExtPackPuel
+;amd64 %ORACLE%=VBoxExtPackPuel, NTamd64
+
+;x86 [VBoxExtPackPuel]
+;amd64 [VBoxExtPackPuel.NTamd64]
+%VBoxExtPackPuel.DrvDesc% = VBoxExtPackPuelInstall, root\VBoxExtPackPuel
+
+[VBoxExtPackPuelInstall]
+CopyFiles = VBoxExtPackPuelInstall.Files
+
+[VBoxExtPackPuelInstall.Files]
+VBoxEhciR0.r0,,,2
+VBoxNvmeR0.r0,,,2
+VBoxPciRawR0.r0,,,2
+
+[Strings]
+ORACLE = "Oracle Corporation"
+VBoxExtPackPuel.DrvDesc = "VirtualBox PUEL ExtPack drivers"
+VBoxExtPackPuel.DskDesc = "VirtualBox PUEL ExtPack drivers"
+
Index: trunk/src/VBox/Installer/win/Scripts/VMMR0.inf
===================================================================
--- trunk/src/VBox/Installer/win/Scripts/VMMR0.inf	(revision 71955)
+++ trunk/src/VBox/Installer/win/Scripts/VMMR0.inf	(revision 71955)
@@ -0,0 +1,67 @@
+; $Id$
+;; @file
+; VMMR0.inf - VirtualBox VMM drivers.
+;
+
+;
+; Copyright (C) 2018 Oracle Corporation
+;
+; This file is part of VirtualBox Open Source Edition (OSE), as
+; available from http://www.virtualbox.org. This file is free software;
+; you can redistribute it and/or modify it under the terms of the GNU
+; General Public License (GPL) as published by the Free Software
+; Foundation, in version 2 as it comes in the "COPYING" file of the
+; VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+; hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+;
+; The contents of this file may alternatively be used under the terms
+; of the Common Development and Distribution License Version 1.0
+; (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+; VirtualBox OSE distribution, in which case the provisions of the
+; CDDL are applicable instead of those of the GPL.
+;
+; You may elect to license modified versions of this file under the
+; terms and conditions of either the GPL or the CDDL or both.
+;
+
+[Version]
+Signature   = "$Windows NT$"
+Class       = System
+ClassGuid   = {4d36e97d-e325-11ce-bfc1-08002be10318}
+CatalogFile = VMMR0.cat
+Provider    = %ORACLE%
+;edit-DriverVer  = 08/26/2008,2.00.0000
+
+[SourceDisksNames]
+1=%VBoxVMM.DskDesc%,"",,
+
+[SourceDisksFiles]
+VMMR0.r0=1
+VBoxDDR0.r0=1
+VBoxDD2R0.r0=1
+
+[DestinationDirs]
+DefaultDestDir = 12
+VBoxVMMInstall.Files = 12
+
+[Manufacturer]
+;x86 %ORACLE%=VBoxVMM
+;amd64 %ORACLE%=VBoxVMM, NTamd64
+
+;x86 [VBoxVMM]
+;amd64 [VBoxVMM.NTamd64]
+%VBoxVMM.DrvDesc% = VBoxVMMInstall, root\VBoxVMM
+
+[VBoxVMMInstall]
+CopyFiles = VBoxVMMInstall.Files
+
+[VBoxVMMInstall.Files]
+VMMR0.r0,,,2
+VBoxDDR0.r0,,,2
+VBoxDD2R0.r0,,,2
+
+[Strings]
+ORACLE = "Oracle Corporation"
+VBoxVMM.DrvDesc = "VirtualBox VMM drivers"
+VBoxVMM.DskDesc = "VirtualBox VMM drivers"
+